using System;
using System.Runtime.InteropServices;

namespace ZoneStripper
{
	/// <summary>
	/// Summary description for Win32.
	/// </summary>
	public class Win32
	{
		private Win32() {}

		public static void DeleteStream(string path, string stream) {
			if(!DeleteFile(path + ":" + stream)) {
				Marshal.ThrowExceptionForHR(Marshal.GetHRForLastWin32Error());
			}
		}

		public static bool StreamExists(string path, string stream) {
			IntPtr handle;

			handle = CreateFile(path + ":" + stream, GENERIC_READ, FILE_SHARE_READ, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero);
			
			bool retVal = (int)handle == -1 ? false : true;
			CloseHandle(handle);
			return retVal;
		}

		#region constants
		private const uint GENERIC_READ			= 0x80000000;
		private const uint GENERIC_WRITE		= 0x40000000;
		
		private const uint CREATE_NEW			= 1;
		private const uint CREATE_ALWAYS		= 2;
		private const uint OPEN_EXISTING		= 3;
		private const uint OPEN_ALWAYS			= 4;
		private const uint TRUNCATE_EXISTING	= 5;

		private const uint FILE_BEGIN			= 0;
		private const uint FILE_CURRENT			= 1;
		private const uint FILE_END 			= 2;

		private const uint FILE_SHARE_NONE		= 0;
		private const uint FILE_SHARE_READ		= 1;
		#endregion

		#region DllImports
		[DllImport("kernel32.dll", SetLastError=true, CharSet = CharSet.Auto)]
		private static extern IntPtr CreateFile(string filename, uint access, uint sharemode, IntPtr security_attributes, uint creation,  uint flags, IntPtr template);

		[DllImport("kernel32.dll", SetLastError=true, CharSet = CharSet.Auto)]
		private static extern bool CloseHandle(IntPtr handle);

		[DllImport("kernel32.dll", SetLastError=true, CharSet = CharSet.Auto)]
		private static extern bool DeleteFile(string filename);
		#endregion
	}
}
